Loading...
Searching...
No Matches
juce::TextEditor Class Reference

## Detailed Description

An editable text box.

A TextEditor can either be in single- or multi-line mode, and supports mixed fonts and colours.

See also
  TextEditor::Listener, Label

The documentation for this class was generated from the following file:

- juce_gui_basics/widgets/juce_TextEditor.h

Inheritance diagram for juce::TextEditor:

## Classes

class | Listener
| Receives callbacks from a TextEditor component when it changes. More...
class | InputFilter
| Base class for input filters that can be applied to a TextEditor to restrict the text that can be entered. More...
class | LengthAndCharacterRestriction
| An input filter for a TextEditor that limits the length of text and/or the characters that it may contain. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide TextEditor drawing functionality. More...

## Public Types

enum | ColourIds { backgroundColourId = 0x1000200 , textColourId = 0x1000201 , highlightColourId = 0x1000202 , highlightedTextColourId = 0x1000203 , outlineColourId = 0x1000205 , focusedOutlineColourId = 0x1000206 , shadowColourId = 0x1000207 }
| A set of colour IDs to use to change the colour of various aspects of the editor. More...
Public Types inherited from juce::TextInputTarget
enum | VirtualKeyboardType { textKeyboard = 0 , numericKeyboard , decimalKeyboard , urlKeyboard , emailAddressKeyboard , phoneNumberKeyboard , passwordKeyboard }
| A set of possible on-screen keyboard types, for use in the getKeyboardType() method. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| TextEditor (const String &componentName=String(), juce_wchar passwordCharacter=0)
| Creates a new, empty text editor.
| ~TextEditor () override
| Destructor.
void | setMultiLine (bool shouldBeMultiLine, bool shouldWordWrap=true)
| Puts the editor into either multi- or single-line mode.
bool | isMultiLine () const
| Returns true if the editor is in multi-line mode.
void | setReturnKeyStartsNewLine (bool shouldStartNewLine)
| Changes the behaviour of the return key.
bool | getReturnKeyStartsNewLine () const
| Returns the value set by setReturnKeyStartsNewLine().
void | setTabKeyUsedAsCharacter (bool shouldTabKeyBeUsed)
| Indicates whether the tab key should be accepted and used to input a tab character, or whether it gets ignored.
bool | isTabKeyUsedAsCharacter () const
| Returns true if the tab key is being used for input.
void | setEscapeAndReturnKeysConsumed (bool shouldBeConsumed) noexcept
| This can be used to change whether escape and return keypress events are propagated up to the parent component.
void | setReadOnly (bool shouldBeReadOnly)
| Changes the editor to read-only mode.
bool | isReadOnly () const noexcept
| Returns true if the editor is in read-only mode.
void | setCaretVisible (bool shouldBeVisible)
| Makes the caret visible or invisible.
bool | isCaretVisible () const noexcept
| Returns true if the caret is enabled.
void | setScrollbarsShown (bool shouldBeEnabled)
| Enables or disables scrollbars (this only applies when in multi-line mode).
bool | areScrollbarsShown () const noexcept
| Returns true if scrollbars are enabled.
void | setPasswordCharacter (juce_wchar passwordCharacter)
| Changes the password character used to disguise the text.
juce_wchar | getPasswordCharacter () const noexcept
| Returns the current password character.
void | setPopupMenuEnabled (bool menuEnabled)
| Allows a right-click menu to appear for the editor.
bool | isPopupMenuEnabled () const noexcept
| Returns true if the right-click menu is enabled.
bool | isPopupMenuCurrentlyActive () const noexcept
| Returns true if a popup-menu is currently being displayed.
void | setFont (const Font &newFont)
| Sets the font to use for newly added text.
void | applyFontToAllText (const Font &newFont, bool changeCurrentFont=true)
| Applies a font to all the text in the editor.
const Font & | getFont () const noexcept
| Returns the font that's currently being used for new text.
void | applyColourToAllText (const Colour &newColour, bool changeCurrentTextColour=true)
| Applies a colour to all the text in the editor.
void | setWhitespaceUnderlined (bool shouldUnderlineWhitespace) noexcept
| Sets whether whitespace should be underlined when the editor font is underlined.
bool | isWhitespaceUnderlined () const noexcept
| Returns true if whitespace is underlined for underlined fonts.
void | setSelectAllWhenFocused (bool shouldSelectAll)
| If set to true, focusing on the editor will highlight all its text.
void | setTextToShowWhenEmpty (const String &text, Colour colourToUse)
| When the text editor is empty, it can be set to display a message.
String | getTextToShowWhenEmpty () const noexcept
| Returns the text that will be shown when the text editor is empty.
void | setScrollBarThickness (int newThicknessPixels)
| Changes the size of the scrollbars that are used.
void | addListener (Listener *newListener)
| Registers a listener to be told when things happen to the text.
void | removeListener (Listener *listenerToRemove)
| Deregisters a listener.
String | getText () const
| Returns the entire contents of the editor.
String | getTextInRange (const Range< int > &textRange) const override
| Returns a section of the contents of the editor.
bool | isEmpty () const
| Returns true if there are no characters in the editor.
void | setText (const String &newText, bool sendTextChangeMessage=true)
| Sets the entire content of the editor.
Value & | getTextValue ()
| Returns a Value object that can be used to get or set the text.
void | insertTextAtCaret (const String &textToInsert) override
| Inserts some text at the current caret position.
void | clear ()
| Deletes all the text from the editor.
void | cut ()
| Deletes the currently selected region.
void | copy ()
| Copies the currently selected region to the clipboard.
void | paste ()
| Pastes the contents of the clipboard into the editor at the caret position.
int | getCaretPosition () const override
| Returns the current index of the caret.
void | setCaretPosition (int newIndex)
| Moves the caret to be in front of a given character.
void | scrollEditorToPositionCaret (int desiredCaretX, int desiredCaretY)
| Attempts to scroll the text editor so that the caret ends up at a specified position.
Rectangle< int > | getCaretRectangleForCharIndex (int index) const override
| Get the graphical position of the caret for a particular index in the text.
void | setHighlightedRegion (const Range< int > &newSelection) override
| Selects a section of the text.
Range< int > | getHighlightedRegion () const override
| Returns the range of characters that are selected.
String | getHighlightedText () const
| Returns the section of text that is currently selected.
int | getTextIndexAt (int x, int y) const
| Finds the index of the character at a given position.
int | getTextIndexAt (Point< int >) const
| Finds the index of the character at a given position.
int | getCharIndexForPoint (Point< int > point) const override
| Like getTextIndexAt, but doesn't snap to the beginning/end of the range for points vertically outside the text.
int | getTotalNumChars () const override
| Counts the number of characters in the text.
int | getTextWidth () const
| Returns the total width of the text, as it is currently laid-out.
int | getTextHeight () const
| Returns the maximum height of the text, as it is currently laid-out.
void | setIndents (int newLeftIndent, int newTopIndent)
| Changes the size of the gap at the top and left-edge of the editor.
int | getTopIndent () const noexcept
| Returns the gap at the top edge of the editor.
int | getLeftIndent () const noexcept
| Returns the gap at the left edge of the editor.
void | setBorder (BorderSize< int > border)
| Changes the size of border left around the edge of the component.
BorderSize< int > | getBorder () const
| Returns the size of border around the edge of the component.
void | setScrollToShowCursor (bool shouldScrollToShowCaret)
| Used to disable the auto-scrolling which keeps the caret visible.
void | setJustification (Justification newJustification)
| Modifies the justification of the text within the editor window.
Justification | getJustificationType () const noexcept
| Returns the type of justification, as set in setJustification().
void | setLineSpacing (float newLineSpacing) noexcept
| Sets the line spacing of the TextEditor.
float | getLineSpacing () const noexcept
| Returns the current line spacing of the TextEditor.
RectangleList< int > | getTextBounds (Range< int > textRange) const override
| Returns the bounding box for a range of text in the editor.
void | moveCaretToEnd ()
bool | moveCaretLeft (bool moveInWholeWordSteps, bool selecting)
bool | moveCaretRight (bool moveInWholeWordSteps, bool selecting)
bool | moveCaretUp (bool selecting)
bool | moveCaretDown (bool selecting)
bool | pageUp (bool selecting)
bool | pageDown (bool selecting)
bool | scrollDown ()
bool | scrollUp ()
bool | moveCaretToTop (bool selecting)
bool | moveCaretToStartOfLine (bool selecting)
bool | moveCaretToEnd (bool selecting)
bool | moveCaretToEndOfLine (bool selecting)
bool | deleteBackwards (bool moveInWholeWordSteps)
bool | deleteForwards (bool moveInWholeWordSteps)
bool | copyToClipboard ()
bool | cutToClipboard ()
bool | pasteFromClipboard ()
bool | selectAll ()
bool | undo ()
bool | redo ()
virtual void | addPopupMenuItems (PopupMenu &menuToAddTo, const MouseEvent *mouseClickEvent)
| This adds the items to the popup menu.
virtual void | performPopupMenuAction (int menuItemID)
| This is called to perform one of the items that was shown on the popup menu.
void | setInputFilter (InputFilter *newFilter, bool takeOwnership)
| Sets an input filter that should be applied to this editor.
InputFilter * | getInputFilter () const noexcept
| Returns the current InputFilter, as set by setInputFilter().
void | setInputRestrictions (int maxTextLength, const String &allowedCharacters=String())
| Sets limits on the characters that can be entered.
void | setKeyboardType (VirtualKeyboardType type) noexcept
| Sets the type of virtual keyboard that should be displayed when this editor has focus.
void | setClicksOutsideDismissVirtualKeyboard (bool)
| Sets the behaviour of mouse/touch interactions outside this component.
bool | getClicksOutsideDismissVirtualKeyboard () const
| Returns true if the editor is configured to hide the virtual keyboard when the mouse is pressed on another component.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | paintOverChildren (Graphics &) override
| Components can override this method to draw over the top of their children.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseDoubleClick (const MouseEvent &) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
| Called when the mouse-wheel is moved.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
bool | keyStateChanged (bool) override
| Called when a key is pressed or released.
void | focusGained (FocusChangeType) override
| Called to indicate that this component has just acquired the keyboard focus.
void | focusLost (FocusChangeType) override
| Called to indicate that this component has just lost the keyboard focus.
void | resized () override
| Called when this component's size has been changed.
void | enablementChanged () override
| Callback to indicate that this component has been enabled or disabled.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
void | parentHierarchyChanged () override
| Called to indicate that the component's parents have changed.
bool | isTextInputActive () const override
| Returns true if this input target is currently accepting input.
void | setTemporaryUnderlining (const Array< Range< int > > &) override
| Sets a number of temporarily underlined sections.
VirtualKeyboardType | getKeyboardType () override
| Returns the target's preference for the type of keyboard that would be most appropriate.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::TextInputTarget
| TextInputTarget ()=default
virtual | ~TextInputTarget ()=default
| Destructor.
Rectangle< int > | getCaretRectangle () const
| Returns the position of the caret, relative to the component's origin.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from juce::TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.

## Public Attributes

std::function< void()> | onTextChange
| You can assign a lambda to this callback object to have it called when the text is changed.
std::function< void()> | onReturnKey
| You can assign a lambda to this callback object to have it called when the return key is pressed.
std::function< void()> | onEscapeKey
| You can assign a lambda to this callback object to have it called when the escape key is pressed.
std::function< void()> | onFocusLost
| You can assign a lambda to this callback object to have it called when the editor loses key focus.

## Protected Member Functions

void | scrollToMakeSureCursorIsVisible ()
| Scrolls the minimum distance needed to get the caret into view.
void | textChanged ()
| Used internally to dispatch a text-change message.
void | newTransaction ()
| Begins a new transaction in the UndoManager.
virtual void | returnPressed ()
| Can be overridden to intercept return key presses directly.
virtual void | escapePressed ()
| Can be overridden to intercept escape key presses directly.
Protected Member Functions inherited from juce::SettableTooltipClient
| SettableTooltipClient ()=default

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Member Enums

## ColourIds

enum juce::TextEditor::ColourIds

A set of colour IDs to use to change the colour of various aspects of the editor.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

NB: You can also set the caret colour using CaretComponent::caretColourId

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The colour to use for the text component's background - this can be transparent if necessary.
textColourId | The colour that will be used when text is added to the editor. Note that because the editor can contain multiple colours, calling this method won't change the colour of existing text - to do that, use the applyColourToAllText() method
highlightColourId | The colour with which to fill the background of highlighted sections of the text - this can be transparent if you don't want to show any highlighting.
highlightedTextColourId | The colour with which to draw the text in highlighted sections.
outlineColourId | If this is non-transparent, it will be used to draw a box around the edge of the component.
focusedOutlineColourId | If this is non-transparent, it will be used to draw a box around the edge of the component when it has focus.
shadowColourId | If this is non-transparent, it'll be used to draw an inner shadow around the edge of the editor.

## Constructors and Destructors

## TextEditor()

juce::TextEditor::TextEditor | ( | const String & | componentName = String(),
|  | juce_wchar | passwordCharacter = 0 )

explicit

Creates a new, empty text editor.

Parameters

  componentName | the name to pass to the component for it to use as its name

  passwordCharacter

  if this is not zero, this character will be used as a replacement for all characters that are drawn on screen - e.g. to create a password-style textbox containing circular blobs instead of text, you could set this value to 0x25cf, which is the unicode character for a black splodge (not all fonts include this, though), or 0x2022, which is a bullet (probably the best choice for linux).

Referenced by juce::TextEditor::LookAndFeelMethods::drawTextEditorOutline(), juce::TextEditor::LookAndFeelMethods::fillTextEditorBackground(), juce::TextEditor::InputFilter::filterNewText(), juce::TextEditor::LengthAndCharacterRestriction::filterNewText(), juce::TextEditor::Listener::textEditorEscapeKeyPressed(), juce::TextEditor::Listener::textEditorFocusLost(), juce::TextEditor::Listener::textEditorReturnKeyPressed(), and juce::TextEditor::Listener::textEditorTextChanged().

## ~TextEditor()

juce::TextEditor::~TextEditor | ( |  | ) |

override

Destructor.

## Member Functions

## setMultiLine()

void juce::TextEditor::setMultiLine | ( | bool | shouldBeMultiLine,
|  | bool | shouldWordWrap = true )

Puts the editor into either multi- or single-line mode.

By default, the editor will be in single-line mode, so use this if you need a multi-line editor.

See also the setReturnKeyStartsNewLine() method, which will also need to be turned on if you want a multi-line editor with line-breaks.

Parameters

  shouldBeMultiLine | whether the editor should be multi- or single-line.
  shouldWordWrap | sets whether long lines should be broken up in multi-line editors. If this is false and scrollbars are enabled a horizontal scrollbar will be shown.

See also
  isMultiLine, setReturnKeyStartsNewLine, setScrollbarsShown

## isMultiLine()

bool juce::TextEditor::isMultiLine | ( |  | ) | const

Returns true if the editor is in multi-line mode.

## setReturnKeyStartsNewLine()

void juce::TextEditor::setReturnKeyStartsNewLine | ( | bool | shouldStartNewLine | ) |

Changes the behaviour of the return key.

If set to true, the return key will insert a new-line into the text; if false it will trigger a call to the TextEditor::Listener::textEditorReturnKeyPressed() method. By default this is set to false, and when true it will only insert new-lines when in multi-line mode (see setMultiLine()).

## getReturnKeyStartsNewLine()

bool juce::TextEditor::getReturnKeyStartsNewLine | ( |  | ) | const

inline

Returns the value set by setReturnKeyStartsNewLine().

See setReturnKeyStartsNewLine() for more info.

## setTabKeyUsedAsCharacter()

void juce::TextEditor::setTabKeyUsedAsCharacter | ( | bool | shouldTabKeyBeUsed | ) |

Indicates whether the tab key should be accepted and used to input a tab character, or whether it gets ignored.

By default the tab key is ignored, so that it can be used to switch keyboard focus between components.

## isTabKeyUsedAsCharacter()

bool juce::TextEditor::isTabKeyUsedAsCharacter | ( |  | ) | const

inline

Returns true if the tab key is being used for input.

See also
  setTabKeyUsedAsCharacter

## setEscapeAndReturnKeysConsumed()

void juce::TextEditor::setEscapeAndReturnKeysConsumed | ( | bool | shouldBeConsumed | ) |

noexcept

This can be used to change whether escape and return keypress events are propagated up to the parent component.

The default here is true, meaning that these events are not allowed to reach the parent, but you may want to allow them through so that they can trigger other actions, e.g. closing a dialog box, etc.

## setReadOnly()

void juce::TextEditor::setReadOnly | ( | bool | shouldBeReadOnly | ) |

Changes the editor to read-only mode.

By default, the text editor is not read-only. If you're making it read-only, you might also want to call setCaretVisible (false) to get rid of the caret.

The text can still be highlighted and copied when in read-only mode.

See also
  isReadOnly, setCaretVisible

## isReadOnly()

bool juce::TextEditor::isReadOnly | ( |  | ) | const

noexcept

Returns true if the editor is in read-only mode.

Referenced by isCaretVisible().

## setCaretVisible()

void juce::TextEditor::setCaretVisible | ( | bool | shouldBeVisible | ) |

Makes the caret visible or invisible.

By default the caret is visible.

See also
  setCaretColour, setCaretPosition

References setCaretVisible().

Referenced by setCaretVisible().

## isCaretVisible()

bool juce::TextEditor::isCaretVisible | ( |  | ) | const

inline noexcept

Returns true if the caret is enabled.

See also
  setCaretVisible

References isCaretVisible(), and isReadOnly().

Referenced by isCaretVisible().

## setScrollbarsShown()

void juce::TextEditor::setScrollbarsShown | ( | bool | shouldBeEnabled | ) |

Enables or disables scrollbars (this only applies when in multi-line mode).

When the text gets too long to fit in the component, a scrollbar can appear to allow it to be scrolled. Even when this is enabled, the scrollbar will be hidden unless it's needed.

By default scrollbars are enabled.

## areScrollbarsShown()

bool juce::TextEditor::areScrollbarsShown | ( |  | ) | const

inline noexcept

Returns true if scrollbars are enabled.

See also
  setScrollbarsShown

## setPasswordCharacter()

void juce::TextEditor::setPasswordCharacter | ( | juce_wchar | passwordCharacter | ) |

Changes the password character used to disguise the text.

Parameters

  passwordCharacter

  if this is not zero, this character will be used as a replacement for all characters that are drawn on screen - e.g. to create a password-style textbox containing circular blobs instead of text, you could set this value to 0x25cf, which is the unicode character for a black splodge (not all fonts include this, though), or 0x2022, which is a bullet (probably the best choice for linux).

## getPasswordCharacter()

juce_wchar juce::TextEditor::getPasswordCharacter | ( |  | ) | const

inline noexcept

Returns the current password character.

See also
  setPasswordCharacter

## setPopupMenuEnabled()

void juce::TextEditor::setPopupMenuEnabled | ( | bool | menuEnabled | ) |

Allows a right-click menu to appear for the editor.

(This defaults to being enabled).

If enabled, right-clicking (or command-clicking on the Mac) will pop up a menu of options such as cut/copy/paste, undo/redo, etc.

## isPopupMenuEnabled()

bool juce::TextEditor::isPopupMenuEnabled | ( |  | ) | const

inline noexcept

Returns true if the right-click menu is enabled.

See also
  setPopupMenuEnabled

## isPopupMenuCurrentlyActive()

bool juce::TextEditor::isPopupMenuCurrentlyActive | ( |  | ) | const

inline noexcept

Returns true if a popup-menu is currently being displayed.

## setFont()

void juce::TextEditor::setFont | ( | const Font & | newFont | ) |

Sets the font to use for newly added text.

This will change the font that will be used next time any text is added or entered into the editor. It won't change the font of any existing text - to do that, use applyFontToAllText() instead.

See also
  applyFontToAllText

## applyFontToAllText()

void juce::TextEditor::applyFontToAllText | ( | const Font & | newFont,
|  | bool | changeCurrentFont = true )

Applies a font to all the text in the editor.

This function also calls applyColourToAllText (findColour (TextEditor::ColourIds::textColourId), false);

If the changeCurrentFont argument is true then this will also set the new font as the font to be used for any new text that's added.

See also
  setFont

## getFont()

const Font & juce::TextEditor::getFont | ( |  | ) | const

inline noexcept

Returns the font that's currently being used for new text.

See also
  setFont

## applyColourToAllText()

void juce::TextEditor::applyColourToAllText | ( | const Colour & | newColour,
|  | bool | changeCurrentTextColour = true )

Applies a colour to all the text in the editor.

If the changeCurrentTextColour argument is true then this will also set the new colour as the colour to be used for any new text that's added.

## setWhitespaceUnderlined()

void juce::TextEditor::setWhitespaceUnderlined | ( | bool | shouldUnderlineWhitespace | ) |

inline noexcept

Sets whether whitespace should be underlined when the editor font is underlined.

See also
  isWhitespaceUnderlined

## isWhitespaceUnderlined()

bool juce::TextEditor::isWhitespaceUnderlined | ( |  | ) | const

inline noexcept

Returns true if whitespace is underlined for underlined fonts.

See also
  setWhitespaceIsUnderlined

## setSelectAllWhenFocused()

void juce::TextEditor::setSelectAllWhenFocused | ( | bool | shouldSelectAll | ) |

If set to true, focusing on the editor will highlight all its text.

(Set to false by default).

This is useful for boxes where you expect the user to re-enter all the text when they focus on the component, rather than editing what's already there.

## setTextToShowWhenEmpty()

void juce::TextEditor::setTextToShowWhenEmpty | ( | const String & | text,
|  | Colour | colourToUse )

When the text editor is empty, it can be set to display a message.

This is handy for things like telling the user what to type in the box - the string is only displayed, it's not taken to actually be the contents of the editor.

## getTextToShowWhenEmpty()

String juce::TextEditor::getTextToShowWhenEmpty | ( |  | ) | const

inline noexcept

Returns the text that will be shown when the text editor is empty.

See also
  setTextToShowWhenEmpty

## setScrollBarThickness()

void juce::TextEditor::setScrollBarThickness | ( | int | newThicknessPixels | ) |

Changes the size of the scrollbars that are used.

Handy if you need smaller scrollbars for a small text box.

## addListener()

void juce::TextEditor::addListener | ( | Listener * | newListener | ) |

Registers a listener to be told when things happen to the text.

See also
  removeListener

## removeListener()

void juce::TextEditor::removeListener | ( | Listener * | listenerToRemove | ) |

Deregisters a listener.

See also
  addListener

## getText()

String juce::TextEditor::getText | ( |  | ) | const

Returns the entire contents of the editor.

## getTextInRange()

String juce::TextEditor::getTextInRange | ( | const Range< int > & | textRange | ) | const

override virtual

Returns a section of the contents of the editor.

Implements juce::TextInputTarget.

## isEmpty()

bool juce::TextEditor::isEmpty | ( |  | ) | const

Returns true if there are no characters in the editor.

This is far more efficient than calling getText().isEmpty().

## setText()

void juce::TextEditor::setText | ( | const String & | newText,
|  | bool | sendTextChangeMessage = true )

Sets the entire content of the editor.

This will clear the editor and insert the given text (using the current text colour and font). You can set the current text colour using

setColour (TextEditor::textColourId, ...);
juce::Component::setColour
void setColour(int colourID, Colour newColour)
Registers a colour to be used for a particular purpose.
juce::TextEditor::textColourId
@ textColourId
The colour that will be used when text is added to the editor.
Definition juce_TextEditor.h:221

Parameters

  newText | the text to add
  sendTextChangeMessage | if true, this will cause a change message to be sent to all the listeners.

See also
  insertTextAtCaret

## getTextValue()

Value & juce::TextEditor::getTextValue | ( |  | ) |

Returns a Value object that can be used to get or set the text.

Bear in mind that this operate quite slowly if your text box contains large amounts of text, as it needs to dynamically build the string that's involved. It's best used for small text boxes.

## insertTextAtCaret()

void juce::TextEditor::insertTextAtCaret | ( | const String & | textToInsert | ) |

override virtual

Inserts some text at the current caret position.

If a section of the text is highlighted, it will be replaced by this string, otherwise it will be inserted.

To delete a section of text, you can use setHighlightedRegion() to highlight it, and call insertTextAtCaret (String()).

See also
  setCaretPosition, getCaretPosition, setHighlightedRegion

Implements juce::TextInputTarget.

## clear()

void juce::TextEditor::clear | ( |  | ) |

Deletes all the text from the editor.

## cut()

void juce::TextEditor::cut | ( |  | ) |

Deletes the currently selected region.

This doesn't copy the deleted section to the clipboard - if you need to do that, call copy() first.

See also
  copy, paste, SystemClipboard

## copy()

void juce::TextEditor::copy | ( |  | ) |

Copies the currently selected region to the clipboard.

See also
  cut, paste, SystemClipboard

## paste()

void juce::TextEditor::paste | ( |  | ) |

Pastes the contents of the clipboard into the editor at the caret position.

See also
  cut, copy, SystemClipboard

## getCaretPosition()

int juce::TextEditor::getCaretPosition | ( |  | ) | const

override virtual

Returns the current index of the caret.

See also
  setCaretPosition

Implements juce::TextInputTarget.

## setCaretPosition()

void juce::TextEditor::setCaretPosition | ( | int | newIndex | ) |

Moves the caret to be in front of a given character.

See also
  getCaretPosition, moveCaretToEnd

## scrollEditorToPositionCaret()

void juce::TextEditor::scrollEditorToPositionCaret | ( | int | desiredCaretX,
|  | int | desiredCaretY )

Attempts to scroll the text editor so that the caret ends up at a specified position.

This won't affect the caret's position within the text, it tries to scroll the entire editor vertically and horizontally so that the caret is sitting at the given position (relative to the top-left of this component).

Depending on the amount of text available, it might not be possible to scroll far enough for the caret to reach this exact position, but it will go as far as it can in that direction.

## getCaretRectangleForCharIndex()

Rectangle< int > juce::TextEditor::getCaretRectangleForCharIndex | ( | int | index | ) | const

override virtual

Get the graphical position of the caret for a particular index in the text.

The rectangle returned is relative to the component's top-left corner.

Implements juce::TextInputTarget.

## setHighlightedRegion()

void juce::TextEditor::setHighlightedRegion | ( | const Range< int > & | newSelection | ) |

override virtual

Selects a section of the text.

Implements juce::TextInputTarget.

## getHighlightedRegion()

Range< int > juce::TextEditor::getHighlightedRegion | ( |  | ) | const

inline override virtual

Returns the range of characters that are selected.

If nothing is selected, this will return an empty range.

See also
  setHighlightedRegion

Implements juce::TextInputTarget.

## getHighlightedText()

String juce::TextEditor::getHighlightedText | ( |  | ) | const

Returns the section of text that is currently selected.

## getTextIndexAt() [1/2]

int juce::TextEditor::getTextIndexAt | ( | int | x,
|  | int | y ) const

Finds the index of the character at a given position.

The coordinates are relative to the component's top-left.

References x, and y.

## getTextIndexAt() [2/2]

int juce::TextEditor::getTextIndexAt | ( | Point< int > |  | ) | const

Finds the index of the character at a given position.

The coordinates are relative to the component's top-left.

## getCharIndexForPoint()

int juce::TextEditor::getCharIndexForPoint | ( | Point< int > | point | ) | const

override virtual

Like getTextIndexAt, but doesn't snap to the beginning/end of the range for points vertically outside the text.

Implements juce::TextInputTarget.

## getTotalNumChars()

int juce::TextEditor::getTotalNumChars | ( |  | ) | const

override virtual

Counts the number of characters in the text.

This is quicker than getting the text as a string if you just need to know the length.

Implements juce::TextInputTarget.

## getTextWidth()

int juce::TextEditor::getTextWidth | ( |  | ) | const

Returns the total width of the text, as it is currently laid-out.

This may be larger than the size of the TextEditor, and can change when the TextEditor is resized or the text changes.

## getTextHeight()

int juce::TextEditor::getTextHeight | ( |  | ) | const

Returns the maximum height of the text, as it is currently laid-out.

This may be larger than the size of the TextEditor, and can change when the TextEditor is resized or the text changes.

## setIndents()

void juce::TextEditor::setIndents | ( | int | newLeftIndent,
|  | int | newTopIndent )

Changes the size of the gap at the top and left-edge of the editor.

By default there's a gap of 4 pixels.

## getTopIndent()

int juce::TextEditor::getTopIndent | ( |  | ) | const

inline noexcept

Returns the gap at the top edge of the editor.

See also
  setIndents

## getLeftIndent()

int juce::TextEditor::getLeftIndent | ( |  | ) | const

inline noexcept

Returns the gap at the left edge of the editor.

See also
  setIndents

## setBorder()

void juce::TextEditor::setBorder | ( | BorderSize< int > | border | ) |

Changes the size of border left around the edge of the component.

See also
  getBorder

## getBorder()

BorderSize< int > juce::TextEditor::getBorder | ( |  | ) | const

Returns the size of border around the edge of the component.

See also
  setBorder

## setScrollToShowCursor()

void juce::TextEditor::setScrollToShowCursor | ( | bool | shouldScrollToShowCaret | ) |

Used to disable the auto-scrolling which keeps the caret visible.

If true (the default), the editor will scroll when the caret moves offscreen. If set to false, it won't.

## setJustification()

void juce::TextEditor::setJustification | ( | Justification | newJustification | ) |

Modifies the justification of the text within the editor window.

## getJustificationType()

Justification juce::TextEditor::getJustificationType | ( |  | ) | const

inline noexcept

Returns the type of justification, as set in setJustification().

## setLineSpacing()

void juce::TextEditor::setLineSpacing | ( | float | newLineSpacing | ) |

noexcept

Sets the line spacing of the TextEditor.

The default (and minimum) value is 1.0 and values > 1.0 will increase the line spacing as a multiple of the line height e.g. for double-spacing call this method with an argument of 2.0.

## getLineSpacing()

float juce::TextEditor::getLineSpacing | ( |  | ) | const

inline noexcept

Returns the current line spacing of the TextEditor.

## getTextBounds()

RectangleList< int > juce::TextEditor::getTextBounds | ( | Range< int > | textRange | ) | const

override virtual

Returns the bounding box for a range of text in the editor.

As the range may span multiple lines, this method returns a RectangleList.

The bounds are relative to the component's top-left and may extend beyond the bounds of the component if the text is long and word wrapping is disabled.

Implements juce::TextInputTarget.

## moveCaretToEnd() [1/2]

void juce::TextEditor::moveCaretToEnd | ( |  | ) |

## moveCaretLeft()

bool juce::TextEditor::moveCaretLeft | ( | bool | moveInWholeWordSteps,
|  | bool | selecting )

## moveCaretRight()

bool juce::TextEditor::moveCaretRight | ( | bool | moveInWholeWordSteps,
|  | bool | selecting )

## moveCaretUp()

bool juce::TextEditor::moveCaretUp | ( | bool | selecting | ) |

## moveCaretDown()

bool juce::TextEditor::moveCaretDown | ( | bool | selecting | ) |

## pageUp()

bool juce::TextEditor::pageUp | ( | bool | selecting | ) |

## pageDown()

bool juce::TextEditor::pageDown | ( | bool | selecting | ) |

## scrollDown()

bool juce::TextEditor::scrollDown | ( |  | ) |

## scrollUp()

bool juce::TextEditor::scrollUp | ( |  | ) |

## moveCaretToTop()

bool juce::TextEditor::moveCaretToTop | ( | bool | selecting | ) |

## moveCaretToStartOfLine()

bool juce::TextEditor::moveCaretToStartOfLine | ( | bool | selecting | ) |

## moveCaretToEnd() [2/2]

bool juce::TextEditor::moveCaretToEnd | ( | bool | selecting | ) |

## moveCaretToEndOfLine()

bool juce::TextEditor::moveCaretToEndOfLine | ( | bool | selecting | ) |

## deleteBackwards()

bool juce::TextEditor::deleteBackwards | ( | bool | moveInWholeWordSteps | ) |

## deleteForwards()

bool juce::TextEditor::deleteForwards | ( | bool | moveInWholeWordSteps | ) |

## copyToClipboard()

bool juce::TextEditor::copyToClipboard | ( |  | ) |

## cutToClipboard()

bool juce::TextEditor::cutToClipboard | ( |  | ) |

## pasteFromClipboard()

bool juce::TextEditor::pasteFromClipboard | ( |  | ) |

## selectAll()

bool juce::TextEditor::selectAll | ( |  | ) |

## undo()

bool juce::TextEditor::undo | ( |  | ) |

## redo()

bool juce::TextEditor::redo | ( |  | ) |

## addPopupMenuItems()

virtual void juce::TextEditor::addPopupMenuItems | ( | PopupMenu & | menuToAddTo,
|  | const MouseEvent * | mouseClickEvent )

virtual

This adds the items to the popup menu.

By default it adds the cut/copy/paste items, but you can override this if you need to replace these with your own items.

If you want to add your own items to the existing ones, you can override this, call the base class's addPopupMenuItems() method, then append your own items.

When the menu has been shown, performPopupMenuAction() will be called to perform the item that the user has chosen.

The default menu items will be added using item IDs from the StandardApplicationCommandIDs namespace.

If this was triggered by a mouse-click, the mouseClickEvent parameter will be a pointer to the info about it, or may be null if the menu is being triggered by some other means.

See also
  performPopupMenuAction, setPopupMenuEnabled, isPopupMenuEnabled

## performPopupMenuAction()

virtual void juce::TextEditor::performPopupMenuAction | ( | int | menuItemID | ) |

virtual

This is called to perform one of the items that was shown on the popup menu.

If you've overridden addPopupMenuItems(), you should also override this to perform the actions that you've added.

If you've overridden addPopupMenuItems() but have still left the default items on the menu, remember to call the superclass's performPopupMenuAction() so that it can perform the default actions if that's what the user clicked on.

See also
  addPopupMenuItems, setPopupMenuEnabled, isPopupMenuEnabled

## setInputFilter()

void juce::TextEditor::setInputFilter | ( | InputFilter * | newFilter,
|  | bool | takeOwnership )

Sets an input filter that should be applied to this editor.

The filter can be nullptr, to remove any existing filters. If takeOwnership is true, then the filter will be owned and deleted by the editor when no longer needed.

## getInputFilter()

InputFilter * juce::TextEditor::getInputFilter | ( |  | ) | const

inline noexcept

Returns the current InputFilter, as set by setInputFilter().

## setInputRestrictions()

void juce::TextEditor::setInputRestrictions | ( | int | maxTextLength,
|  | const String & | allowedCharacters = String() )

Sets limits on the characters that can be entered.

This is just a shortcut that passes an instance of the LengthAndCharacterRestriction class to setInputFilter().

Parameters

  maxTextLength | if this is > 0, it sets a maximum length limit; if 0, no limit is set
  allowedCharacters | if this is non-empty, then only characters that occur in this string are allowed to be entered into the editor.

## setKeyboardType()

void juce::TextEditor::setKeyboardType | ( | VirtualKeyboardType | type | ) |

inline noexcept

Sets the type of virtual keyboard that should be displayed when this editor has focus.

## setClicksOutsideDismissVirtualKeyboard()

void juce::TextEditor::setClicksOutsideDismissVirtualKeyboard | ( | bool |  | ) |

Sets the behaviour of mouse/touch interactions outside this component.

If true, then presses outside of the TextEditor will dismiss the virtual keyboard. If false, then the virtual keyboard will remain onscreen for as long as the TextEditor has keyboard focus.

## getClicksOutsideDismissVirtualKeyboard()

bool juce::TextEditor::getClicksOutsideDismissVirtualKeyboard | ( |  | ) | const

inline

Returns true if the editor is configured to hide the virtual keyboard when the mouse is pressed on another component.

## paint()

void juce::TextEditor::paint | ( | Graphics & | g | ) |

override virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## paintOverChildren()

void juce::TextEditor::paintOverChildren | ( | Graphics & | g | ) |

override virtual

Components can override this method to draw over the top of their children.

For most drawing operations, it's better to use the normal paint() method, but if you need to overlay something on top of the children, this can be used.

See also
  paint, Graphics

Reimplemented from juce::Component.

## mouseDown()

void juce::TextEditor::mouseDown | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseUp()

void juce::TextEditor::mouseUp | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::Component.

## mouseDrag()

void juce::TextEditor::mouseDrag | ( | const MouseEvent & | event | ) |

override virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::Component.

## mouseDoubleClick()

void juce::TextEditor::mouseDoubleClick | ( | const MouseEvent & | event | ) |

override virtual

Called when a mouse button has been double-clicked on a component.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp

Reimplemented from juce::Component.

## mouseWheelMove()

void juce::TextEditor::mouseWheelMove | ( | const MouseEvent & | event,
|  | const MouseWheelDetails & | wheel )

override virtual

Called when the mouse-wheel is moved.

This callback is sent to the component that the mouse is over when the wheel is moved.

If not overridden, a component will forward this message to its parent, so that parent components can collect mouse-wheel messages that happen to child components which aren't interested in them. (Bear in mind that if you attach a component as a mouse-listener to other components, then those wheel moves will also end up calling this method and being passed up to the parents, which may not be what you intended to happen).

Parameters

  event | details about the mouse event
  wheel | details about the mouse wheel movement

Reimplemented from juce::Component.

## keyPressed()

bool juce::TextEditor::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## keyStateChanged()

bool juce::TextEditor::keyStateChanged | ( | bool | isKeyDown | ) |

override virtual

Called when a key is pressed or released.

Whenever a key on the keyboard is pressed or released (including modifier keys like shift and ctrl), this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, then any KeyListeners that have been registered with this component will have their keyStateChanged methods called. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

To find out which keys are up or down at any time, see the KeyPress::isKeyCurrentlyDown() method.

Parameters

  isKeyDown | true if a key has been pressed; false if it has been released

See also
  keyPressed, KeyPress, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## focusGained()

void juce::TextEditor::focusGained | ( | FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just acquired the keyboard focus.

See also
  focusLost, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## focusLost()

void juce::TextEditor::focusLost | ( | FocusChangeType | cause | ) |

override virtual

Called to indicate that this component has just lost the keyboard focus.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented from juce::Component.

## resized()

void juce::TextEditor::resized | ( |  | ) |

override virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from juce::Component.

## enablementChanged()

void juce::TextEditor::enablementChanged | ( |  | ) |

override virtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented from juce::Component.

## lookAndFeelChanged()

void juce::TextEditor::lookAndFeelChanged | ( |  | ) |

override virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## parentHierarchyChanged()

void juce::TextEditor::parentHierarchyChanged | ( |  | ) |

override virtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, this method will be called on all of its children (recursively - so all children of its children will also be called as well).

Subclasses can override this if they need to react to this in some way.

See also
  getParentComponent, isShowing, ComponentListener::componentParentHierarchyChanged

Reimplemented from juce::Component.

## isTextInputActive()

bool juce::TextEditor::isTextInputActive | ( |  | ) | const

override virtual

Returns true if this input target is currently accepting input.

For example, a text editor might return false if it's in read-only mode.

Implements juce::TextInputTarget.

## setTemporaryUnderlining()

void juce::TextEditor::setTemporaryUnderlining | ( | const Array< Range< int > > & | underlinedRegions | ) |

override virtual

Sets a number of temporarily underlined sections.

This is needed by MS Windows input method UI.

Implements juce::TextInputTarget.

## getKeyboardType()

VirtualKeyboardType juce::TextEditor::getKeyboardType | ( |  | ) |

override virtual

Returns the target's preference for the type of keyboard that would be most appropriate.

This may be ignored, depending on the capabilities of the OS.

Reimplemented from juce::TextInputTarget.

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::TextEditor::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

## scrollToMakeSureCursorIsVisible()

void juce::TextEditor::scrollToMakeSureCursorIsVisible | ( |  | ) |

protected

Scrolls the minimum distance needed to get the caret into view.

## textChanged()

void juce::TextEditor::textChanged | ( |  | ) |

protected

Used internally to dispatch a text-change message.

## newTransaction()

void juce::TextEditor::newTransaction | ( |  | ) |

protected

Begins a new transaction in the UndoManager.

## returnPressed()

virtual void juce::TextEditor::returnPressed | ( |  | ) |

protected virtual

Can be overridden to intercept return key presses directly.

## escapePressed()

virtual void juce::TextEditor::escapePressed | ( |  | ) |

protected virtual

Can be overridden to intercept escape key presses directly.

References juce::Component::Component(), and juce::Desktop::getInstance().

## Member Data Documentation

## onTextChange

std::function<void()> juce::TextEditor::onTextChange

You can assign a lambda to this callback object to have it called when the text is changed.

## onReturnKey

std::function<void()> juce::TextEditor::onReturnKey

You can assign a lambda to this callback object to have it called when the return key is pressed.

## onEscapeKey

std::function<void()> juce::TextEditor::onEscapeKey

You can assign a lambda to this callback object to have it called when the escape key is pressed.

## onFocusLost

std::function<void()> juce::TextEditor::onFocusLost

You can assign a lambda to this callback object to have it called when the editor loses key focus.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited